// SCW2750U_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SCW2750U_Demo.h"
#include "SCW2750U_DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCW2750U_DemoDlg dialog

CSCW2750U_DemoDlg::CSCW2750U_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSCW2750U_DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSCW2750U_DemoDlg)
	m_Track1ReadData = _T("");
	m_Track1ReadLength = 0;
	m_Track1WriteData = _T("");
	m_Track1WriteLength = 0;
	m_Track2ReadData = _T("");
	m_Track2ReadLength = 0;
	m_Track2WriteData = _T("");
	m_Track2WriteLength = 0;
	m_Track3ReadData = _T("");
	m_Track3ReadLength = 0;
	m_Track3WriteData = _T("");
	m_Track3WriteLength = 0;
	m_Track1Enable = FALSE;
	m_Track2Enable = FALSE;
	m_Track3Enable = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSCW2750U_DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSCW2750U_DemoDlg)
	DDX_Control(pDX, IDC_SET_TRACK2_BPI, m_Ctrl_SetTrack2BPI);
	DDX_Control(pDX, IDC_FREQUENCY, m_Ctrl_Frequency);
	DDX_Control(pDX, IDC_DISABLE_AUTO_RUN, m_Ctrl_DisableAutoRun);
	DDX_Control(pDX, IDC_ENABLE_AUTO_RUN, m_Ctrl_EnableAutoRun);
	DDX_Control(pDX, IDC_SET_TRACK23_TO_STANDARD, m_Ctrl_SetTrack23ToStandard);
	DDX_Control(pDX, IDC_SELECT_CHAR_SET, m_Ctrl_SelectCharSet);
	DDX_Control(pDX, IDC_WRITE, m_Ctrl_Write);
	DDX_Control(pDX, IDC_READ, m_Ctrl_Read);
	DDX_Control(pDX, IDC_DISCONNECT, m_Ctrl_Disconnect);
	DDX_Control(pDX, IDC_CONNECT, m_Ctrl_Connect);
	DDX_Text(pDX, IDC_TRACK1_READ_DATA, m_Track1ReadData);
	DDX_Text(pDX, IDC_TRACK1_READ_LENGTH, m_Track1ReadLength);
	DDX_Text(pDX, IDC_TRACK1_WRITE_DATA, m_Track1WriteData);
	DDX_Text(pDX, IDC_TRACK1_WRITE_LENGTH, m_Track1WriteLength);
	DDX_Text(pDX, IDC_TRACK2_READ_DATA, m_Track2ReadData);
	DDX_Text(pDX, IDC_TRACK2_READ_LENGTH, m_Track2ReadLength);
	DDX_Text(pDX, IDC_TRACK2_WRITE_DATA, m_Track2WriteData);
	DDX_Text(pDX, IDC_TRACK2_WRITE_LENGTH, m_Track2WriteLength);
	DDX_Text(pDX, IDC_TRACK3_READ_DATA, m_Track3ReadData);
	DDX_Text(pDX, IDC_TRACK3_READ_LENGTH, m_Track3ReadLength);
	DDX_Text(pDX, IDC_TRACK3_WRITE_DATA, m_Track3WriteData);
	DDX_Text(pDX, IDC_TRACK3_WRITE_LENGTH, m_Track3WriteLength);
	DDX_Check(pDX, IDC_TRACK1_ENABLE, m_Track1Enable);
	DDX_Check(pDX, IDC_TRACK2_ENABLE, m_Track2Enable);
	DDX_Check(pDX, IDC_TRACK3_ENABLE, m_Track3Enable);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSCW2750U_DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CSCW2750U_DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_CBN_SELENDOK(IDC_SELECT_CHAR_SET, OnSelendokSelectCharSet)
	ON_CBN_SELENDOK(IDC_SET_TRACK23_TO_STANDARD, OnSelendokSetTrack23ToStandard)
	ON_BN_CLICKED(IDC_ENABLE_AUTO_RUN, OnEnableAutoRun)
	ON_BN_CLICKED(IDC_DISABLE_AUTO_RUN, OnDisableAutoRun)
	ON_CBN_SELENDOK(IDC_SET_TRACK2_BPI, OnSelendokSetTrack2Bpi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCW2750U_DemoDlg message handlers

BOOL CSCW2750U_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Setting the Dialog
	m_Ctrl_Connect.EnableWindow(TRUE);
	m_Ctrl_Disconnect.EnableWindow(FALSE);
	m_Ctrl_SelectCharSet.EnableWindow(FALSE);
	m_Ctrl_SetTrack23ToStandard.EnableWindow(FALSE);
	m_Ctrl_SetTrack2BPI.EnableWindow(FALSE);
	m_Ctrl_Read.EnableWindow(FALSE);
	m_Ctrl_Write.EnableWindow(FALSE);
	m_Ctrl_EnableAutoRun.EnableWindow(FALSE);
	m_Ctrl_DisableAutoRun.EnableWindow(FALSE);
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSCW2750U_DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSCW2750U_DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSCW2750U_DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSCW2750U_DemoDlg::OnConnect() 
{
	// Encoder Connect...
	if( !m_SCW2750U.Connect() )
	{
		AfxMessageBox("SCW2750U Encoder Not Found...");
	}
	else
	{
		// Initial Encoder
		m_SCW2750U.InitialReader();
		m_SCW2750U.Beep();

		// Setting the Dialog
		m_Ctrl_Connect.EnableWindow(FALSE);
		m_Ctrl_Disconnect.EnableWindow(TRUE);
		m_Ctrl_Read.EnableWindow(TRUE);
		m_Ctrl_Write.EnableWindow(TRUE);
		m_Ctrl_EnableAutoRun.EnableWindow(TRUE);
		m_Ctrl_DisableAutoRun.EnableWindow(FALSE);
		m_Track1WriteData = m_Track2WriteData = m_Track3WriteData = "";
		m_Track1ReadData = m_Track2ReadData = m_Track3ReadData = "";
		m_Track1WriteLength = m_Track2WriteLength = m_Track3WriteLength = 0;
		m_Track1ReadLength = m_Track2ReadLength = m_Track3ReadLength = 0;
		nAutoRun = 0;
		nFrequency = 0;

		// Get Encoder Setting
		if( m_SCW2750U.GetEncoderSetting() )
		{
			// Setting the Dialog
			m_Ctrl_SelectCharSet.EnableWindow(TRUE);
			m_Ctrl_SetTrack23ToStandard.EnableWindow(TRUE);
			m_Ctrl_SetTrack2BPI.EnableWindow(TRUE);
			m_Ctrl_SelectCharSet.SetCurSel(m_SCW2750U.chCharSet-1);
			m_Ctrl_SetTrack23ToStandard.SetCurSel(m_SCW2750U.chTrack2Standard-1);
			m_Ctrl_SetTrack2BPI.SetCurSel(0);
			m_SCW2750U.SetTrack2_75BPI(TRUE);
		}
		UpdateData(FALSE);

		// Enable Timer1 ( Detect the Encoder online?? )
		SetTimer(1,500,NULL);
	}			
}

void CSCW2750U_DemoDlg::OnDisconnect() 
{
	// Disable Timer
	KillTimer(1);
	KillTimer(2);

	// Encoder Disconnect
	m_SCW2750U.CancelCommand();
	m_SCW2750U.Disconnect();

	// Setting the Dialog
	m_Ctrl_Connect.EnableWindow(TRUE);
	m_Ctrl_Disconnect.EnableWindow(FALSE);
	m_Ctrl_SelectCharSet.EnableWindow(FALSE);
	m_Ctrl_SetTrack23ToStandard.EnableWindow(FALSE);
	m_Ctrl_SetTrack2BPI.EnableWindow(FALSE);
	m_Ctrl_Read.EnableWindow(FALSE);
	m_Ctrl_Write.EnableWindow(FALSE);
	m_Ctrl_EnableAutoRun.EnableWindow(FALSE);
	m_Ctrl_DisableAutoRun.EnableWindow(FALSE);
	m_Track1WriteData = m_Track2WriteData = m_Track3WriteData = "";
	m_Track1ReadData = m_Track2ReadData = m_Track3ReadData = "";
	m_Track1WriteLength = m_Track2WriteLength = m_Track3WriteLength = 0;
	m_Track1ReadLength = m_Track2ReadLength = m_Track3ReadLength = 0;
	UpdateData(FALSE);		
}

void CSCW2750U_DemoDlg::OnClose() 
{
	m_SCW2750U.Disconnect();
	CDialog::OnClose();
}

void CSCW2750U_DemoDlg::OnSelendokSelectCharSet() 
{
	// User Clicked the [ Char Set ]
	if( !m_SCW2750U.SelectCharSet( m_Ctrl_SelectCharSet.GetCurSel()+1 ) )
	{
		AfxMessageBox("Command Failed...");
	}
}

void CSCW2750U_DemoDlg::OnSelendokSetTrack23ToStandard() 
{
	// User Clicked the [ Track2/3 Standard ]
	if( !m_SCW2750U.SetTrack23Standard( m_Ctrl_SetTrack23ToStandard.GetCurSel()+1,m_Ctrl_SetTrack23ToStandard.GetCurSel()+1 ) )
	{
		AfxMessageBox("Command Failed...");
	}
}

void CSCW2750U_DemoDlg::OnSelendokSetTrack2Bpi() 
{
	// User Clicked the [ Track2 BPI ]
	if( m_Ctrl_SetTrack2BPI.GetCurSel() == 0 )
	{
		// Set Track2 to 75 BPI
		m_SCW2750U.SetTrack2_75BPI(TRUE);
	}
	else
	{
		// Set Track2 to 210 BPI
		m_SCW2750U.SetTrack2_75BPI(FALSE);
	}
}

void CSCW2750U_DemoDlg::OnTimer(UINT nIDEvent) 
{
	// Timer 1  ( Detect the Encoder online?? )
	if( ( nIDEvent == 1 ) && ( m_SCW2750U.QueryReaderState() ) )
	{
		UpdateData(TRUE);
		m_Track1WriteLength = m_Track1WriteData.GetLength();
		m_Track2WriteLength = m_Track2WriteData.GetLength();
		m_Track3WriteLength = m_Track3WriteData.GetLength();

		CString nStr;
		m_Ctrl_Frequency.ResetContent();
		nStr.Format("%03d",nFrequency);
		m_Ctrl_Frequency.AddString(nStr);

		UpdateData(FALSE);
	}

	// Timer2 ( Encoder R/W Auto Run  )
	else if( nIDEvent == 2 )
	{
		KillTimer(2);

		// Auto Run [ Write Card ]
		if( ( nAutoRun == 1 ) && ( m_SCW2750U.WriteFinish() ) )
		{
			OnRead();
			return;
		}

		// Read Card
		else if( ( nAutoRun != 1 ) && ( m_SCW2750U.ReadyToRead(nTrack1Data,nTrack2Data,nTrack3Data) ) )
		{
			m_Track1ReadData = "";
			m_Track1ReadLength = 0;
			if( nTrack1Data[0] != 0xFF )
			{
				m_Track1ReadData += nTrack1Data;
				m_Track1ReadLength = m_Track1ReadData.GetLength();
			}

			m_Track2ReadData ="";
			m_Track2ReadLength = 0;
			if( nTrack2Data[0] != 0xFF )			
			{
				m_Track2ReadData += nTrack2Data;
				m_Track2ReadLength = m_Track2ReadData.GetLength();
			}

			m_Track3ReadData = "";
			m_Track3ReadLength = 0;
			if( nTrack3Data[0] != 0xFF )			
			{
				m_Track3ReadData += nTrack3Data;
				m_Track3ReadLength = m_Track3ReadData.GetLength();
			}
			UpdateData(FALSE);

			if( nAutoRun == 2 )
			{
				nFrequency++;
				nAutoRun = 1;
				OnWrite();
			}
			return;
		}
		SetTimer(2,500,NULL);
	}
	else if( nIDEvent == 3 )
	{}
	else if( nIDEvent == 4 )
	{}
	else
	{
		KillTimer(1);
		KillTimer(2);
		m_SCW2750U.Disconnect();
		AfxMessageBox("SCW2750U Encoder Remove...");

		m_Ctrl_Connect.EnableWindow(TRUE);
		m_Ctrl_Disconnect.EnableWindow(FALSE);
		m_Ctrl_SelectCharSet.EnableWindow(FALSE);
		m_Ctrl_SetTrack23ToStandard.EnableWindow(FALSE);
		m_Ctrl_Read.EnableWindow(FALSE);
		m_Ctrl_Write.EnableWindow(FALSE);
		m_Track1WriteData = m_Track2WriteData = m_Track3WriteData = "";
		m_Track1ReadData = m_Track2ReadData = m_Track3ReadData = "";
		m_Track1WriteLength = m_Track2WriteLength = m_Track3WriteLength = 0;
		m_Track1ReadLength = m_Track2ReadLength = m_Track3ReadLength = 0;
		UpdateData(FALSE);
	}
}

void CSCW2750U_DemoDlg::OnRead() 
{
	// User Clicked the [ Read ]

	KillTimer(2);

	UpdateData(TRUE);

//	m_SCW2750U.CancelCommand();

	// if m_Track1Enable is true , than read Track1 Data 
	// if m_Track2Enable is true , than read Track2 Data 
	// if m_Track3Enable is true , than read Track3 Data 
	if( m_SCW2750U.ReadTrack(m_Track1Enable,m_Track2Enable,m_Track3Enable) )
	{
		if( nAutoRun == 1 )
		{
			nAutoRun = 2;
		}
		SetTimer(2,500,NULL);
	}
}

void CSCW2750U_DemoDlg::OnWrite() 
{
	// User Clicked the [ Write ] 

	UCHAR nTrack1Buf[120];
	UCHAR nTrack2Buf[120];
	UCHAR nTrack3Buf[120];

	KillTimer(2);

	UpdateData(TRUE);
	
	// Track1 Data Process
	nTrack1Buf[0] = '\0';
	if( m_Track1Enable )
	{
		if( nAutoRun == 1 )
		{
			CString nStr;
			nStr.Format("%03d",nFrequency);
			m_Track1WriteData = m_Track1WriteData.Left(m_Track1WriteData.GetLength()-3) + nStr;
		}
		for(int i=0;i<m_Track1WriteData.GetLength();i++)
		{
			nTrack1Buf[i] = m_Track1WriteData[i];
		}
		nTrack1Buf[i] = '\0';
	}

	// Track2 Data Process
	nTrack2Buf[0] = '\0';
	if( m_Track2Enable )
	{
		if( nAutoRun == 1)
		{
			CString nStr;
			nStr.Format("%03d",nFrequency);
			m_Track2WriteData = m_Track2WriteData.Left(m_Track2WriteData.GetLength()-3) + nStr;
		}
		for(int i=0;i<m_Track2WriteData.GetLength();i++)
		{
			nTrack2Buf[i] = m_Track2WriteData[i];
		}
		nTrack2Buf[i] = '\0';
	}

	// Track3 Data Process
	nTrack3Buf[0] = '\0';
	if( m_Track3Enable )
	{
		if( nAutoRun == 1 )
		{
			CString nStr;
			nStr.Format("%03d",nFrequency);
			m_Track3WriteData = m_Track3WriteData.Left(m_Track3WriteData.GetLength()-3) + nStr;
		}
		for(int i=0;i<m_Track3WriteData.GetLength();i++)
		{
			nTrack3Buf[i] = m_Track3WriteData[i];
		}
		nTrack3Buf[i] = '\0';
	}

	UpdateData(FALSE);

	m_SCW2750U.CancelCommand();

	// Send Track1 , Track2 and Track3 Data to Encoder
	if( m_SCW2750U.WriteTrack(nTrack1Buf,nTrack2Buf,nTrack3Buf) )
	{
		// if the data ok , than the Encoder ready to write
		if( !m_SCW2750U.ReadyToWrite() )
		{
			AfxMessageBox("Data Faile...");
			nAutoRun = 0;
		}
		else
		{
			// Auto Run
			if( nAutoRun == 1 )
			{
				SetTimer(2,500,NULL);
			}
		}
	}
}

void CSCW2750U_DemoDlg::OnEnableAutoRun() 
{
	// User Clicked the [ Enable Auto Run ( Write ) ]

	m_SCW2750U.CancelCommand();
	m_Ctrl_SelectCharSet.EnableWindow(FALSE);
	m_Ctrl_SetTrack23ToStandard.EnableWindow(FALSE);
	m_Ctrl_SetTrack2BPI.EnableWindow(FALSE);
	m_Ctrl_Read.EnableWindow(FALSE);
	m_Ctrl_Write.EnableWindow(FALSE);
	m_Ctrl_EnableAutoRun.EnableWindow(FALSE);
	m_Ctrl_DisableAutoRun.EnableWindow(TRUE);
	nFrequency = 0;
	nAutoRun = 1;
	OnWrite();
}

void CSCW2750U_DemoDlg::OnDisableAutoRun() 
{
	// User Clicked the [ Disable Auto Run ( Write ) ]

	m_SCW2750U.CancelCommand();
	m_Ctrl_SelectCharSet.EnableWindow(TRUE);
	m_Ctrl_SetTrack23ToStandard.EnableWindow(TRUE);
	m_Ctrl_SetTrack2BPI.EnableWindow(TRUE);
	m_Ctrl_Read.EnableWindow(TRUE);
	m_Ctrl_Write.EnableWindow(TRUE);
	m_Ctrl_EnableAutoRun.EnableWindow(TRUE);
	m_Ctrl_DisableAutoRun.EnableWindow(FALSE);	
	nAutoRun = 0;
}
