// SCW2750U_DemoDlg.h : header file
//
#include "SCW2750UAPI.h"

#if !defined(AFX_SCW2750U_DEMODLG_H__9CB23C63_7E53_49A7_9C4A_D83BB28D5273__INCLUDED_)
#define AFX_SCW2750U_DEMODLG_H__9CB23C63_7E53_49A7_9C4A_D83BB28D5273__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSCW2750U_DemoDlg dialog

class CSCW2750U_DemoDlg : public CDialog
{
private:
	SCW2750UEncoder m_SCW2750U;
	UINT nAutoRun;
	UINT nFrequency;

	UCHAR nTrack1Data[120];
	UCHAR nTrack2Data[120];
	UCHAR nTrack3Data[120];


// Construction
public:
	CSCW2750U_DemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSCW2750U_DemoDlg)
	enum { IDD = IDD_SCW2750U_DEMO_DIALOG };
	CComboBox	m_Ctrl_SetTrack2BPI;
	CListBox	m_Ctrl_Frequency;
	CButton	m_Ctrl_DisableAutoRun;
	CButton	m_Ctrl_EnableAutoRun;
	CComboBox	m_Ctrl_SetTrack23ToStandard;
	CComboBox	m_Ctrl_SelectCharSet;
	CButton	m_Ctrl_Write;
	CButton	m_Ctrl_Read;
	CButton	m_Ctrl_Disconnect;
	CButton	m_Ctrl_Connect;
	CString	m_Track1ReadData;
	UINT	m_Track1ReadLength;
	CString	m_Track1WriteData;
	UINT	m_Track1WriteLength;
	CString	m_Track2ReadData;
	UINT	m_Track2ReadLength;
	CString	m_Track2WriteData;
	UINT	m_Track2WriteLength;
	CString	m_Track3ReadData;
	UINT	m_Track3ReadLength;
	CString	m_Track3WriteData;
	UINT	m_Track3WriteLength;
	BOOL	m_Track1Enable;
	BOOL	m_Track2Enable;
	BOOL	m_Track3Enable;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCW2750U_DemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSCW2750U_DemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRead();
	afx_msg void OnWrite();
	afx_msg void OnSelendokSelectCharSet();
	afx_msg void OnSelendokSetTrack23ToStandard();
	afx_msg void OnEnableAutoRun();
	afx_msg void OnDisableAutoRun2();
	afx_msg void OnDisableAutoRun();
	afx_msg void OnSelendokSetTrack2Bpi();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCW2750U_DEMODLG_H__9CB23C63_7E53_49A7_9C4A_D83BB28D5273__INCLUDED_)
